var months = new Array("January","February","March","April","May","June","July","August","September","October","November","December");
update_interval = 1000;

const format_veryshort = 0;
const format_short = 1;
const format_long = 2;
var format = format_long;

const precision_seconds = 3;
const precision_minutes = 2;
const precision_hours = 1;
const precision_days = 0;
var precision = precision_seconds;

var optionsOpen = 0;

//constructs the event date from saved settings
function get_eventDate()
{
	var eventDate = null;
	var clockerPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("clocker.");

	if (clockerPrefs != null)
	{	
		//alert("in set event date");
		tmonth = clockerPrefs.getCharPref("optMonth");
		tyear = clockerPrefs.getCharPref("optYear");
		tday = clockerPrefs.getCharPref("optDay");
		thour = clockerPrefs.getCharPref("optHour");
		tmin = clockerPrefs.getCharPref("optMinute");
		tsec = clockerPrefs.getCharPref("optSecond");
		//alert('tyear=' + tyear);
		
		tampm = clockerPrefs.getCharPref("optAmpm");
		
		if (tampm == "PM")
			thour = thour + 12;

		eventDate = months[tmonth] + " " + tday + ", " + tyear + " " + thour + ":" + tmin + ":" + tsec;
	}
	
	return eventDate;
}

//continually updates the statusbar
function update_statusbar_clock()
{
var tm;

	tm = get_time_remaining();
	document.getElementById('statusbar-clocker').setAttribute("label", tm);
	window.setTimeout("update_statusbar_clock()", update_interval);
}
		
//returns the time remaining until the event as a string in the user-desired format
function get_time_remaining() 
{
var ed = get_eventDate();
if (ed == null)
{
	   s = "Click here to setup Clocker"
	   return s;
}	   
var then = new Date(ed);
var now = new Date();
var diff;
var s;
var ryears, rdays, rhours, rmins, rseconds;
var years, days, hours, minutes, seconds;
var displayEventDesc;
var eventDesc;
	
	//diff is the total milliseconds remaining until event occurs
	diff = then.getTime() - now.getTime();
	
	if (diff <= 0)
	{
	   s = "CLOCKER DONE!"
	   return s; 
	}

	diff = diff / 1000;
	seconds = diff;  //total seconds remaining

	diff = diff / 60;
	minutes = diff;  //total minutes remaining and so on

	diff = diff / 60;
	hours = diff;

	diff = diff / 24;
	days = diff;

	diff = diff / 365;
	years = diff;
		
	//ryears is the rounded down years remaining. After this
	//figure out the whole number of days, hours, mins, secs remaining.
	s = " "
	a = years;
	ryears = Math.floor(a);

	a = days - (ryears * 365);
	rdays = Math.floor(a);

	a = hours - ((rdays + (ryears * 365)) * 24);
	rhours = Math.floor(a);

	a = minutes - ((rhours + (rdays + (ryears * 365)) * 24) * 60);
	rmins = Math.floor(a);
	   	
	a = seconds - ((rmins + (rhours + ((rdays + (ryears * 365))) * 24) * 60) * 60);
	rseconds = Math.floor(a);

	//get precision and format settings
	var clockerPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("clocker.");
	
	if (clockerPrefs)
	{
		//if (optionsOpen == 0)
		//{
			var opt = clockerPrefs.getCharPref("optFormat"); 
			if (opt == "vshort")
				format = format_veryshort;
			else if (opt == "short")
				format = format_short;
			else			
				format = format_long;
				
			opt = clockerPrefs.getCharPref("optPrecision"); 
			if (opt == "days")
				precision = precision_days;
			else if (opt == "hours")
				precision = precision_hours;
			else if (opt == "minutes")
				precision = precision_minutes;
			else
				precision = precision_seconds;
			
			opt = null;
		//}

		displayEventDesc = clockerPrefs.getBoolPref("optDisplayEvent");   
		eventDesc = clockerPrefs.getCharPref("optEventDesc");
		eventDesc = "Time until " + eventDesc
		
		if (item = document.getElementById("statusbar-clocker"))
		{
			item.setAttribute("tooltiptext", eventDesc); 
			item.style.color = clockerPrefs.getCharPref("optColor");
		}
		
		clockerPrefs = null;	
	}
	
	//return time in correct format
	switch(format)
	{
		case format_veryshort:
			if (ryears != 0)
				s = s + ryears + " ";
			if (rdays != 0)
				s = s + rdays + " ";
			if (rhours >= 0)
				if (precision >= precision_hours)
					s = s + rhours;
			if (rmins >= 0)
				if (precision >= precision_minutes)
					s = s + ":" + rmins;
			if (precision == precision_seconds) 				
				s = s + ":" + rseconds		
			break;
		case format_short:
			if (ryears != 0)
				s = ryears + "y "; 
			if (rdays != 0)
				s = s + rdays + "d "; 
			if (rhours != 0)
				if (precision >= precision_hours)
					s = s + rhours + "h "; 
			if (rmins != 0) 
				if (precision >= precision_minutes)
					s = s + rmins + "m ";
			if (precision == precision_seconds) 
				s = s + rseconds + "s"; 
			break;
		default:
			if (ryears != 0)
			{
				if (ryears == 1)  //singular
					s = ryears + " year "; 
				else   //plural
					s = ryears + " years "; 
			}
			if (rdays != 0)
			{
				if (rdays == 1)
					s = s + rdays + " day "; 
				else
					s = s + rdays + " days "; 
			}
			if (rhours != 0)
				if (precision >= precision_hours)
				{
					if (rhours == 1)
						s = s + rhours + " hour "; 
					else
						s = s + rhours + " hours "; 
				}
			if (rmins != 0)
				if (precision >= precision_minutes)
					s = s + rmins + " minutes "; 
			if (precision == precision_seconds) 
				s = s + rseconds + " seconds"; 
	}	
					
	if (displayEventDesc == true)
	{
		//tack on description if necessary
		s = eventDesc + " - " + s;
	}
		
	return s;			
}

//loads at startup
window.setTimeout("update_statusbar_clock()", 900);
